OpenTTD Source: Blitter_32bppBase Class Reference

OpenTTD Source 12.0-beta1

Public Member Functions | Static Public Member Functions | Static Public Attributes
Blitter_32bppBase Class Reference

Base for all 32bpp blitters. More...

`#include <32bpp_base.hpp>`

Inheritance diagram for Blitter_32bppBase:

## Public Member Functions
uint8 | GetScreenDepth () override
| Get the screen depth this blitter works for. More...
void * | MoveTo (void *video, int x, int y) override
| Move the destination pointer the requested amount x and y, keeping in mind any pitch and bpp of the renderer. More...
void | SetPixel (void *video, int x, int y, uint8 colour) override
| Draw a pixel with a given colour on the video-buffer. More...
void | DrawLine (void *video, int x, int y, int x2, int y2, int screen_width, int screen_height, uint8 colour, int width, int dash) override
| Draw a line with a given colour. More...
void | DrawRect (void *video, int width, int height, uint8 colour) override
| Make a single horizontal line in a single colour on the video-buffer. More...
void | CopyFromBuffer (void *video, const void *src, int width, int height) override
| Copy from a buffer to the screen. More...
void | CopyToBuffer (const void *video, void *dst, int width, int height) override
| Copy from the screen to a buffer. More...
void | CopyImageToBuffer (const void *video, void *dst, int width, int height, int dst_pitch) override
| Copy from the screen to a buffer in a palette format for 8bpp and RGBA format for 32bpp. More...
void | ScrollBuffer (void *video, int &left, int &top, int &width, int &height, int scroll_x, int scroll_y) override
| Scroll the videobuffer some 'x' and 'y' value. More...
int | BufferSize (int width, int height) override
| Calculate how much memory there is needed for an image of this size in the video-buffer. More...
void | PaletteAnimate (const Palette &palette) override
| Called when the 8bpp palette is changed; you should redraw all pixels on the screen that are equal to the 8bpp palette indexes 'first_dirty' to 'first_dirty + count_dirty'. More...
Blitter::PaletteAnimation | UsePaletteAnimation () override
| Check if the blitter uses palette animation at all. More...
int | GetBytesPerPixel () override
| Get how many bytes are needed to store a pixel.
Public Member Functions inherited from Blitter
bool | Is32BppSupported () override
| Can the sprite encoder make use of RGBA sprites?
virtual void | Draw (Blitter::BlitterParams *bp, BlitterMode mode, ZoomLevel zoom)=0
| Draw an image to the screen, given an amount of params defined above.
virtual void | DrawColourMappingRect (void *dst, int width, int height, PaletteID pal)=0
| Draw a colourtable to the screen. More...
virtual bool | NeedsAnimationBuffer ()
| Does this blitter require a separate animation buffer from the video backend?
virtual const char * | GetName ()=0
| Get the name of the blitter, the same as the Factory-instance returns.
virtual void | PostResize ()
| Post resize event.
template<typename SetPixelT >
void | DrawLineGeneric (int x, int y, int x2, int y2, int screen_width, int screen_height, int width, int dash, SetPixelT set_pixel)
Public Member Functions inherited from SpriteEncoder
virtual Sprite * | Encode (const SpriteLoader::Sprite *sprite, AllocatorProc *allocator)=0
| Convert a sprite from the loader to our own format.
virtual uint | GetSpriteAlignment ()
| Get the value which the height and width on a sprite have to be aligned by. More...

## Static Public Member Functions
static Colour | LookupColourInPalette (uint index)
| Look up the colour in the current palette.
static Colour | ComposeColourRGBANoCheck (uint r, uint g, uint b, uint a, Colour current)
| Compose a colour based on RGBA values and the current pixel value.
static Colour | ComposeColourRGBA (uint r, uint g, uint b, uint a, Colour current)
| Compose a colour based on RGBA values and the current pixel value. More...
static Colour | ComposeColourPANoCheck (Colour colour, uint a, Colour current)
| Compose a colour based on Pixel value, alpha value, and the current pixel value.
static Colour | ComposeColourPA (Colour colour, uint a, Colour current)
| Compose a colour based on Pixel value, alpha value, and the current pixel value. More...
static Colour | MakeTransparent (Colour colour, uint nom, uint denom=256)
| Make a pixel looks like it is transparent. More...
static uint8 | MakeDark (uint8 r, uint8 g, uint8 b)
| Make a colour dark grey, for specialized 32bpp remapping. More...
static Colour | MakeDark (Colour colour)
| Make a colour dark grey, for specialized 32bpp remapping. More...
static Colour | MakeGrey (Colour colour)
| Make a colour grey - based. More...
static Colour | ReallyAdjustBrightness (Colour colour, uint8 brightness)
static Colour | AdjustBrightness (Colour colour, uint8 brightness)
static uint8 | GetColourBrightness (Colour colour)

## Static Public Attributes
static const int | DEFAULT_BRIGHTNESS = 128

## Additional Inherited Members
Public Types inherited from Blitter
enum | PaletteAnimation { PALETTE_ANIMATION_NONE, PALETTE_ANIMATION_VIDEO_BACKEND, PALETTE_ANIMATION_BLITTER }
| Types of palette animation. More...

## Detailed Description

Base for all 32bpp blitters.

Definition at line 19 of file 32bpp_base.hpp.

## Member Function Documentation

## ◆ BufferSize()

int Blitter_32bppBase::BufferSize | ( | int | width,
|  | int | height
| ) |  |
| overridevirtual

Calculate how much memory there is needed for an image of this size in the video-buffer.

Parameters

  width | The width of the buffer-to-be.
  height | The height of the buffer-to-be.

Returns
  The size needed for the buffer.

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 143 of file 32bpp_base.cpp.

## ◆ ComposeColourPA()

static Colour Blitter_32bppBase::ComposeColourPA | ( | Colour | colour,
|  | uint | a,
|  | Colour | current
| ) |  |
| inlinestatic

Compose a colour based on Pixel value, alpha value, and the current pixel value.

Handles fully transparent and solid pixels in a special (faster) way.

Definition at line 87 of file 32bpp_base.hpp.

References Colour::a, and ComposeColourPANoCheck().

## ◆ ComposeColourRGBA()

static Colour Blitter_32bppBase::ComposeColourRGBA | ( | uint | r,
|  | uint | g,
|  | uint | b,
|  | uint | a,
|  | Colour | current
| ) |  |
| inlinestatic

Compose a colour based on RGBA values and the current pixel value.

Handles fully transparent and solid pixels in a special (faster) way.

Definition at line 63 of file 32bpp_base.hpp.

References ComposeColourRGBANoCheck().

## ◆ CopyFromBuffer()

void Blitter_32bppBase::CopyFromBuffer | ( | void * | video,
|  | const void * | src,
|  | int | width,
|  | int | height
| ) |  |
| overridevirtual

Copy from a buffer to the screen.

Parameters

  video | The destination pointer (video-buffer).
  src | The buffer from which the data will be read.
  width | The width of the buffer.
  height | The height of the buffer.

Note
  You can not do anything with the content of the buffer, as the blitter can store non-pixel data in it too!

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 48 of file 32bpp_base.cpp.

## ◆ CopyImageToBuffer()

void Blitter_32bppBase::CopyImageToBuffer | ( | const void * | video,
|  | void * | dst,
|  | int | width,
|  | int | height,
|  | int | dst_pitch
| ) |  |
| overridevirtual

Copy from the screen to a buffer in a palette format for 8bpp and RGBA format for 32bpp.

Parameters

  video | The destination pointer (video-buffer).
  dst | The buffer in which the data will be stored.
  width | The width of the buffer.
  height | The height of the buffer.
  dst_pitch | The pitch (byte per line) of the destination buffer.

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 72 of file 32bpp_base.cpp.

Referenced by Blitter_40bppAnim::CopyImageToBuffer().

## ◆ CopyToBuffer()

void Blitter_32bppBase::CopyToBuffer | ( | const void * | video,
|  | void * | dst,
|  | int | width,
|  | int | height
| ) |  |
| overridevirtual

Copy from the screen to a buffer.

Parameters

  video | The destination pointer (video-buffer).
  dst | The buffer in which the data will be stored.
  width | The width of the buffer.
  height | The height of the buffer.

Note
  You can not do anything with the content of the buffer, as the blitter can store non-pixel data in it too!

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 60 of file 32bpp_base.cpp.

## ◆ DrawLine()

void Blitter_32bppBase::DrawLine | ( | void * | video,
|  | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | screen_width,
|  | int | screen_height,
|  | uint8 | colour,
|  | int | width,
|  | int | dash
| ) |  |
| overridevirtual

Draw a line with a given colour.

Parameters

  video | The destination pointer (video-buffer).
  x | The x coordinate from where the line starts.
  y | The y coordinate from where the line starts.
  x2 | The x coordinate to where the line goes.
  y2 | The y coordinate to where the lines goes.
  screen_width | The width of the screen you are drawing in (to avoid buffer-overflows).
  screen_height | The height of the screen you are drawing in (to avoid buffer-overflows).
  colour | A 8bpp mapping colour.
  width | Line width.
  dash | Length of dashes for dashed lines. 0 means solid line.

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 26 of file 32bpp_base.cpp.

## ◆ DrawRect()

void Blitter_32bppBase::DrawRect | ( | void * | video,
|  | int | width,
|  | int | height,
|  | uint8 | colour
| ) |  |
| overridevirtual

Make a single horizontal line in a single colour on the video-buffer.

Parameters

  video | The destination pointer (video-buffer).
  width | The length of the line.
  height | The height of the line.
  colour | A 8bpp mapping colour.

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 34 of file 32bpp_base.cpp.

References LookupColourInPalette().

Referenced by Blitter_40bppAnim::DrawRect(), and Blitter_32bppAnim::DrawRect().

## ◆ GetScreenDepth()

uint8 Blitter_32bppBase::GetScreenDepth | ( |  | ) |
| inlineoverridevirtual

Get the screen depth this blitter works for.

This is either: 8, 16, 24 or 32.

Implements Blitter.

Definition at line 21 of file 32bpp_base.hpp.

## ◆ MakeDark() [1/2]

static Colour Blitter_32bppBase::MakeDark | ( | Colour | colour | ) |
| inlinestatic

Make a colour dark grey, for specialized 32bpp remapping.

Parameters

  colour | the colour to make dark.

Returns
  the new colour, now darker.

Definition at line 132 of file 32bpp_base.hpp.

References MakeDark().

## ◆ MakeDark() [2/2]

static uint8 Blitter_32bppBase::MakeDark | ( | uint8 | r,
|  | uint8 | g,
|  | uint8 | b
| ) |  |
| inlinestatic

Make a colour dark grey, for specialized 32bpp remapping.

Parameters

  r | red component
  g | green component
  b | blue component

Returns
  the brightness value of the new colour, now dark grey.

Definition at line 121 of file 32bpp_base.hpp.

Referenced by MakeDark().

## ◆ MakeGrey()

static Colour Blitter_32bppBase::MakeGrey | ( | Colour | colour | ) |
| inlinestatic

Make a colour grey - based.

Parameters

  colour | the colour to make grey.

Returns
  the new colour, now grey.

Definition at line 144 of file 32bpp_base.hpp.

## ◆ MakeTransparent()

static Colour Blitter_32bppBase::MakeTransparent | ( | Colour | colour,
|  | uint | nom,
|  | uint | denom = `256`
| ) |  |
| inlinestatic

Make a pixel looks like it is transparent.

Parameters

  colour | the colour already on the screen.
  nom | the amount of transparency, nominator, makes colour lighter.
  denom | denominator, makes colour darker.

Returns
  the new colour for the screen.

Definition at line 105 of file 32bpp_base.hpp.

Referenced by Blitter_32bppSimple::DrawColourMappingRect(), and Blitter_32bppAnim::DrawColourMappingRect().

## ◆ MoveTo()

void * Blitter_32bppBase::MoveTo | ( | void * | video,
|  | int | x,
|  | int | y
| ) |  |
| overridevirtual

Move the destination pointer the requested amount x and y, keeping in mind any pitch and bpp of the renderer.

Parameters

  video | The destination pointer (video-buffer) to scroll.
  x | How much you want to scroll to the right.
  y | How much you want to scroll to the bottom.

Returns
  A new destination pointer moved the the requested place.

Implements Blitter.

Definition at line 16 of file 32bpp_base.cpp.

## ◆ PaletteAnimate()

void Blitter_32bppBase::PaletteAnimate | ( | const Palette & | palette | ) |
| overridevirtual

Called when the 8bpp palette is changed; you should redraw all pixels on the screen that are equal to the 8bpp palette indexes 'first_dirty' to 'first_dirty + count_dirty'.

Parameters

  palette | The new palette.

Implements Blitter.

Definition at line 148 of file 32bpp_base.cpp.

## ◆ ScrollBuffer()

void Blitter_32bppBase::ScrollBuffer | ( | void * | video,
|  | int & | left,
|  | int & | top,
|  | int & | width,
|  | int & | height,
|  | int | scroll_x,
|  | int | scroll_y
| ) |  |
| overridevirtual

Scroll the videobuffer some 'x' and 'y' value.

Parameters

  video | The buffer to scroll into.
  left | The left value of the screen to scroll.
  top | The top value of the screen to scroll.
  width | The width of the screen to scroll.
  height | The height of the screen to scroll.
  scroll_x | How much to scroll in X.
  scroll_y | How much to scroll in Y.

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 84 of file 32bpp_base.cpp.

## ◆ SetPixel()

void Blitter_32bppBase::SetPixel | ( | void * | video,
|  | int | x,
|  | int | y,
|  | uint8 | colour
| ) |  |
| overridevirtual

Draw a pixel with a given colour on the video-buffer.

Parameters

  video | The destination pointer (video-buffer).
  x | The x position within video-buffer.
  y | The y position within video-buffer.
  colour | A 8bpp mapping colour.

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 21 of file 32bpp_base.cpp.

## ◆ UsePaletteAnimation()

Blitter::PaletteAnimation Blitter_32bppBase::UsePaletteAnimation | ( |  | ) |
| overridevirtual

Check if the blitter uses palette animation at all.

Returns
  True if it uses palette animation.

Implements Blitter.

Reimplemented in Blitter_40bppAnim.

Definition at line 183 of file 32bpp_base.cpp.

References Blitter::PALETTE_ANIMATION_NONE.

The documentation for this class was generated from the following files:

- src/blitter/32bpp_base.hpp
- src/blitter/32bpp_base.cpp